<?php include_once 'codebase/hyperframe.php' ?><!doctype html>
<html>
<html>
<head>
   <TITLE></TITLE>
   <META NANE="description"  CONTENT="">
   <META NAME="keywords" CONTENT="">
   <META NAME="hf_frame" CONTENT="">
   <META NAME="hf_menu" CONTENT="">
   <META NAME="hf_hide" CONTENT="">
   <META HTTP-EQUIV="Content-Type" CONTENT="text/html; utf-8">
   <link rel=stylesheet href="codebase/standalone.css" type="text/css">
</head>

<body>
<h1>The Plugin Interface</h1>

<h3>and reusable code add-ons</h3>

<p>Hyperframe supports a very simple plugin interface, which allows reusable code blocks of either php or javascript to be included into pages.</p>

<h3>Installing a Plugin</h3>

<p>This is a very straightforward process of expanding the archive (zip, tgz, 7z are permitted formats)&nbsp;into the plugin directory of the site. Since plugins should always be built such that the archive contains a subdirectory whose name matches the plugin, this should result in the files being put into the correct place.</p>

<h3>Configuring a plugin</h3>

<p>A plugin&#39;s own directory may contain a config.php file where customisable settings are stored. For most purposes, adjusting the settings in this should suffice. Other files in the plugin directory may contain replaceable data associated with the plugin&#39;s function. Plugins do not normally have browser-based configuration pages, although in some special cases these may exist.</p>

<h3>Uninstalling</h3>

<p>Plugin removal is a straightforward process of editing any pages&nbsp;which call the plugin to remove such references, and deleting the plugin&#39;s own directory. Since Hyperframe plugins do not add code classes to the system or make any other such invasive modifications, removal should leave the system exactly as it was before installation. Calls to nonexistent plugins may result in entries being written to the server&#39;s php error log, and if error reporting is set on, screen messages.</p>

<h3>Calling a plugin</h3>

<h4>&nbsp; For a plugin using html or php:</h4>

<p style="margin-left: 40px;">In the calling page, enter the following at first place the plugin is needed:<br />
<strong>&lt;?php include(plugin(&#39;pluginname&#39;))?&gt;</strong><br />
&nbsp;replacing pluginname with the name of the plugin.</p>

<h4>&nbsp; For a plugin containing only javascript:</h4>

<p style="margin-left: 40px;"><strong>&lt;?php plugin(&#39;pluginname&#39;)?&gt;</strong></p>

<p>Depending on the nature of a plugin, the call to it may insert formatted text at the that position in the page, cause code to run at that point, or do nothing until a function within the plugin is called or some trigger condition arises, at some later point in the page. Exactly which depends on its purpose, and for this you should consult the plugin documentation.&nbsp;</p>

<h3>The plugin structure</h3>

<p><strong>Naming:</strong> Plugin names must be unique. Names are case sensitive, and it is thus advised to stick to lowercase naming.&nbsp; Names may contain any characters which are legal in <strong>both</strong> linux and Microsoft Windows filesystems. Spaces are not permitted.&nbsp;</p>

<p><strong>Content: </strong>All plugins shall have a file named <strong>plugin.php</strong> in the root of the plugin&#39;s&nbsp; directory. Optionally, a <strong>plugin.js</strong> file may also exist for javascript code. The plugin directory may contain other files as required, and if necessary may contain a subdirectory structure.</p>

<p>Plugins may contain pure HTML, if that is all that is required. If so, there should not be any &lt;html&gt;, &lt;head&gt; or &lt;body&gt; tags, just the formatted text.</p>

<p>In keeping with good programming practices, plugins containing code should expose only a minimum number of global variables. Where global variables are required, these should follow the naming convention <strong>pluginname_variablename</strong> so as to avoid collisions with other plugins.</p>

<p>Code plugins should preferably expose only those functions to the global namespace which need to be called from the invoking page. Where a plugin exposes multiple functions, their naming should be of the form <strong>pluginname_functionname()</strong> -for example <strong>email_send()</strong> -or if using OOP, as&nbsp;<strong>$email-&gt;send(). </strong>This is to reduce the possibility of naming collisions with other plugins.</p>

<p>The only mechanism available in php which provides private functions is OOP, therefore this does suggest the use objects as the best way to code Hyperframe plugins without risk of namespace clashes. However, since OOP is significantly more difficult than conventional coding, we shall not make that an absolute requirement. If you want to code conventionally, just remember to name your functions uniquely and to avoid global variables as far as possible.</p>

<p><strong>Coding Styles:</strong> Hyperframe operates under a policy of openness and customisability. In contrast to most other such products, It is expressly intended that plugin code should be modifiable by the end user. For this reason, lucid and uncomplicated writing styles are preferred. It is recognised that object-oriented code may offer several advantages as regards plugins, and that code compression may improve the loading speed of javascript, thus such techniques may be used <em>where appropriate</em>. However, such features should not be employed solely as a means of obfuscating or overcomplicating code with a view to making it indecipherable. Likewise, the use of meaningless variable names ($a=1, $b=2 etc) is to be considered bad practice.&nbsp; As regards commenting or documentation it is not required that all functions in a plugin be described in detail, but it is preferable if the main ones are.</p>

<p>If using advanced php features, for example anonymous functions, please state clearly the minimum php version required for your plugin.</p>

<p><strong>Licensing:</strong> All plugins offered for inclusion into the Hyperframe project must be fully functional, not time limited, and be released under a recognised free software license.&nbsp;&nbsp; Plugin coders shall retain the rights to their work.</p>

<p style="text-align: center;">&nbsp;</p>

</body>
</html>
