<?php include_once 'codebase/hyperframe.php' ?><h1>Security Enhancements</h1>

<p><strong>Hyperframe is already designed with security in mind. The Web is a hostile environment, and the level of security which would be acceptable&nbsp;on an internal LAN is generally inadequate here. That said, the distribution package has to be supplied in such a format that it is reasonably easy to get started with it. Once the site is up and running, you may wish to consider making a few changes which further increase security.</strong></p>

<p>The choice of a file-based CMS is one of the most positive steps you can take towards better website security, eliminating as it does the risk of SQL code injection. However, you should not be complacent about various other security concerns which apply to all websites.</p>

<p>It goes without saying that non-guessable passwords should be used. Words associated with your business, car&nbsp; types or regsistrations, favourite sports or team names are all <span style="color:#FF0000;">bad</span> examples of passwords. Choose something which <em>you</em> can remember, but no-one else would <em>expect</em> to find as the password.</p>

<p>Hyperframe employs tarpitting, such that repeated bad logins will cause its response to become progressively slower and slower. This makes bruteforce guessing or dictionary attacks much harder. Passwords in-transit between the browser and server are salted and double-encrypted, using a challenge/response mechanism. Passwords are never stored in plaintext on the server, either in memory or on disk. This part of the system took a fair amount of coding time to get the results we wanted, but we feel it&#39;s worth it for the peace of mind it gives.&nbsp; No-one can guarantee that a site will never be hacked, but we feel that any hacker having-a-go at a Hyperframe site will probably decide to try somewhere easier instead.</p>

<p>A few additional changes will make the site even more secure:</p>

<p><strong>Change the site administrator&#39;s username</strong><br />
By default this is &#39;admin&#39; but if you create a new administrative user with a different name, test the new login and then disable &#39;admin&#39; you have a more secure system since any intruder would then have to guess the <em>name</em> as well as the password. The odds of success are obviously much smaller.</p>

<p><strong>Change the administrative key</strong><br />
By default you add &#39;?admin&#39; to a URL to go into admin/editing mode. This value is determined by the <em>editkey</em> value in the siteini.php file, in the sitecfg directory. Changing this to something else will make it hard for an intruder to even put Hyperframe into login mode, let alone login. This measure is highly recommended for any security-sensitive site, as it effectively provides two-factor login. A would-be intruder needs a user&#39;s password, but also needs an item of common knowledge to site editors, one which would probably not be mentioned along with the password since it is already known to staff.</p>

<p>Since v2.4 it is no longer possible to view php scripts in pages with only the admin key, hence in this respect there is no longer the same degree of need for a non-default key. However, it&#39;s still good security practice.</p>

<p><strong>Reduce the session timeout&nbsp; </strong>(and increase the keepalive ping rate to suit)<br />
The timeout as-supplied has to allow for slow-ish hosts. If your site connection is fast and reliable than a shorter timeout should not cause issues, and will significantly reduce the risk of &#39;session resurrection&#39; exploits. See the timeout page for more details.</p>

<p><strong>Change the site hash</strong><br />
This is the &#39;salt&#39; value in siteini.php - and it should be a number from 1 to 9999. Be aware that this change will involve regenerating all user passwords, though, so not advised on existing sites. (This mechanism has had some changes in v2.4 so previous instructions no longer apply)</p>

<p><strong>Restrict the IP addresses the site can be administered from</strong><br />
This feature is controlled by the <em>allowed_ips</em> and <em>prohibited_ips</em> values in the <em>siteini.php</em> security section.<br />
Values are a complete or partial IP address in dotted quad notation, for example 123.123.211.211 is acceptable, and 123.123. will encompass any IP with those as the first two octets. Multiple values are separated by commas. Prohibition overrides allowance. With both values blank there is no IP filtering.&nbsp; Linklocal addresses are filtered, therefore if you access the server internally via a LAN, any allowed list must contain your local range<em>.</em> IPv6 is not currently supported.</p>

<p>The main usage here would be to restrict access to your ISP&#39;s specific IP ranges. Though, you can also restrict access to the IP ranges in use in your World region. This offers some useful protection from regions where hacking is known to be rife. It is not of course an absolute protection, since proxies can be used to get around the restriction. But, it is a useful way of keeping hostile robots out.</p>

<p>To avoid giving away that an IP block is in effect, the response to an admin-mode&nbsp; request from a&nbsp; banned IP is to present an error message which makes it look as if the site is down with a perplexing bug.</p>

<p>IP restrictions do not prevent the site being viewed, only edited.</p>
